Index: codes/icosagcm/trunk/src/timeloop_gcm.f90
===================================================================
--- codes/icosagcm/trunk/src/timeloop_gcm.f90	(revision 150)
+++ codes/icosagcm/trunk/src/timeloop_gcm.f90	(revision 151)
@@ -1,14 +1,33 @@
 MODULE timeloop_gcm_mod
-
+  USE transfert_mod
+  USE icosa
   PRIVATE
   
-  PUBLIC :: timeloop
+  PUBLIC :: init_timeloop, timeloop
 
   INTEGER, PARAMETER :: euler=1, rk4=2, mlf=3
   INTEGER  :: itau_sync=10
 
+  TYPE(t_message) :: req_ps0, req_theta_rhodz0, req_u0, req_q0
+
+  TYPE(t_field),POINTER :: f_phis(:)
+  TYPE(t_field),POINTER :: f_q(:)
+  TYPE(t_field),POINTER :: f_dtheta(:), f_rhodz(:)
+  TYPE(t_field),POINTER :: f_ps(:),f_psm1(:), f_psm2(:)
+  TYPE(t_field),POINTER :: f_u(:),f_um1(:),f_um2(:)
+  TYPE(t_field),POINTER :: f_theta_rhodz(:),f_theta_rhodzm1(:),f_theta_rhodzm2(:)
+  TYPE(t_field),POINTER :: f_dps(:),f_dpsm1(:), f_dpsm2(:)
+  TYPE(t_field),POINTER :: f_du(:),f_dum1(:),f_dum2(:)
+  TYPE(t_field),POINTER :: f_dtheta_rhodz(:),f_dtheta_rhodzm1(:),f_dtheta_rhodzm2(:)
+  TYPE(t_field),POINTER :: f_hflux(:), f_wflux(:), f_hfluxt(:), f_wfluxt(:)  
+
+  INTEGER :: nb_stage, matsuno_period, scheme    
+
+  REAL(rstd),SAVE :: jD_cur, jH_cur
+  REAL(rstd),SAVE :: start_time
+
 CONTAINS
   
-  SUBROUTINE timeloop
+  SUBROUTINE init_timeloop
   USE icosa
   USE dissip_gcm_mod
@@ -19,77 +38,34 @@
   USE physics_mod
   USE mpipara
-  USE IOIPSL
-  USE maxicosa
-  USE check_conserve_mod
+  USE omp_para
   USE trace
   USE transfert_mod
+  USE check_conserve_mod
+  USE ioipsl
   IMPLICIT NONE
-  TYPE(t_field),POINTER :: f_phis(:)
-!  TYPE(t_field),POINTER :: f_theta(:)
-  TYPE(t_field),POINTER :: f_q(:)
-  TYPE(t_field),POINTER :: f_dtheta(:), f_rhodz(:)
-  TYPE(t_field),POINTER :: f_ps(:),f_psm1(:), f_psm2(:)
-  TYPE(t_field),POINTER :: f_u(:),f_um1(:),f_um2(:)
-  TYPE(t_field),POINTER :: f_theta_rhodz(:),f_theta_rhodzm1(:),f_theta_rhodzm2(:)
-  TYPE(t_field),POINTER :: f_dps(:),f_dpsm1(:), f_dpsm2(:)
-  TYPE(t_field),POINTER :: f_du(:),f_dum1(:),f_dum2(:)
-  TYPE(t_field),POINTER :: f_dtheta_rhodz(:),f_dtheta_rhodzm1(:),f_dtheta_rhodzm2(:)
-  TYPE(t_field),POINTER :: f_hflux(:), f_wflux(:), f_hfluxt(:), f_wfluxt(:)
-
-  REAL(rstd),POINTER :: phis(:)
-  REAL(rstd),POINTER :: q(:,:,:)
-  REAL(rstd),POINTER :: ps(:) ,psm1(:), psm2(:)
-  REAL(rstd),POINTER :: u(:,:) , um1(:,:), um2(:,:)
-  REAL(rstd),POINTER :: rhodz(:,:), theta_rhodz(:,:) , theta_rhodzm1(:,:), theta_rhodzm2(:,:)
-  REAL(rstd),POINTER :: dps(:), dpsm1(:), dpsm2(:)
-  REAL(rstd),POINTER :: du(:,:), dum1(:,:), dum2(:,:)
-  REAL(rstd),POINTER :: dtheta_rhodz(:,:),dtheta_rhodzm1(:,:),dtheta_rhodzm2(:,:)
-  REAL(rstd),POINTER :: hflux(:,:),wflux(:,:),hfluxt(:,:),wfluxt(:,:)
-!  REAL(rstd) :: dt, run_length
-  INTEGER :: ind
-  INTEGER :: it,i,j,n, nb_stage, stage, matsuno_period, scheme
-  CHARACTER(len=255) :: scheme_name
-  LOGICAL :: fluxt_zero(ndomain) ! set to .TRUE. to start accumulating fluxes in time
-  CHARACTER(len=7) :: first 
-  REAL(rstd),SAVE :: jD_cur, jH_cur
-  REAL(rstd),SAVE :: start_time
-  LOGICAL, PARAMETER :: check=.FALSE.
-!  INTEGER :: itaumax
-!  REAL(rstd) ::write_period
-!  INTEGER    :: itau_out
-  
-!  dt=90.
-!  CALL getin('dt',dt)
-  
-!  itaumax=100
-!  CALL getin('itaumax',itaumax)
-
-!  run_length=dt*itaumax
-!  CALL getin('run_length',run_length)
-!  itaumax=run_length/dt
-!  PRINT *,'itaumax=',itaumax
-!  dt=dt/scale_factor
-
-! Trends
-  CALL allocate_field(f_dps,field_t,type_real)
-  CALL allocate_field(f_du,field_u,type_real,llm)
-  CALL allocate_field(f_dtheta_rhodz,field_t,type_real,llm)
+
+    CHARACTER(len=255) :: scheme_name
+
+    CALL allocate_field(f_dps,field_t,type_real)
+    CALL allocate_field(f_du,field_u,type_real,llm)
+    CALL allocate_field(f_dtheta_rhodz,field_t,type_real,llm)
 ! Model state at current time step (RK/MLF/Euler)
-  CALL allocate_field(f_phis,field_t,type_real)
-  CALL allocate_field(f_ps,field_t,type_real)
-  CALL allocate_field(f_u,field_u,type_real,llm)
-  CALL allocate_field(f_theta_rhodz,field_t,type_real,llm)
+    CALL allocate_field(f_phis,field_t,type_real)
+    CALL allocate_field(f_ps,field_t,type_real)
+    CALL allocate_field(f_u,field_u,type_real,llm)
+    CALL allocate_field(f_theta_rhodz,field_t,type_real,llm)
 ! Model state at previous time step (RK/MLF)
-  CALL allocate_field(f_psm1,field_t,type_real)
-  CALL allocate_field(f_um1,field_u,type_real,llm)
-  CALL allocate_field(f_theta_rhodzm1,field_t,type_real,llm)
+    CALL allocate_field(f_psm1,field_t,type_real)
+    CALL allocate_field(f_um1,field_u,type_real,llm)
+    CALL allocate_field(f_theta_rhodzm1,field_t,type_real,llm)
 ! Tracers
-  CALL allocate_field(f_q,field_t,type_real,llm,nqtot)
-  CALL allocate_field(f_rhodz,field_t,type_real,llm)
+    CALL allocate_field(f_q,field_t,type_real,llm,nqtot)
+    CALL allocate_field(f_rhodz,field_t,type_real,llm)
 ! Mass fluxes
-  CALL allocate_field(f_hflux,field_u,type_real,llm)    ! instantaneous mass fluxes
-  CALL allocate_field(f_wflux,field_t,type_real,llm+1)  ! computed by caldyn
-  CALL allocate_field(f_hfluxt,field_u,type_real,llm)   ! mass "fluxes" accumulated in time
-  CALL allocate_field(f_wfluxt,field_t,type_real,llm+1)
+    CALL allocate_field(f_hflux,field_u,type_real,llm)    ! instantaneous mass fluxes
+    CALL allocate_field(f_wflux,field_t,type_real,llm+1)  ! computed by caldyn
+    CALL allocate_field(f_hfluxt,field_u,type_real,llm)   ! mass "fluxes" accumulated in time
+    CALL allocate_field(f_wfluxt,field_t,type_real,llm+1)
+
 
 !----------------------------------------------------
@@ -145,93 +121,123 @@
 !----------------------------------------------------
 
-  scheme_name='runge_kutta'
-  CALL getin('scheme',scheme_name)
-
-  SELECT CASE (TRIM(scheme_name))
-  CASE('euler')
-     scheme=euler
-     nb_stage=1
-  CASE ('runge_kutta')
-     scheme=rk4
-     nb_stage=4
-  CASE ('leapfrog_matsuno')
-     scheme=mlf
-     matsuno_period=5
-     CALL getin('matsuno_period',matsuno_period)
-     nb_stage=matsuno_period+1
+
+
+
+
+    scheme_name='runge_kutta'
+    CALL getin('scheme',scheme_name)
+
+    SELECT CASE (TRIM(scheme_name))
+      CASE('euler')
+        scheme=euler
+        nb_stage=1
+      CASE ('runge_kutta')
+        scheme=rk4
+        nb_stage=4
+      CASE ('leapfrog_matsuno')
+        scheme=mlf
+        matsuno_period=5
+        CALL getin('matsuno_period',matsuno_period)
+        nb_stage=matsuno_period+1
      ! Model state 2 time steps ago (MLF)
-     CALL allocate_field(f_psm2,field_t,type_real)
-     CALL allocate_field(f_theta_rhodzm2,field_t,type_real,llm)
-     CALL allocate_field(f_um2,field_u,type_real,llm)
-  CASE default
-     PRINT*,'Bad selector for variable scheme : <', TRIM(scheme_name),             &
-          ' > options are <euler>, <runge_kutta>, <leapfrog_matsuno>'
-     STOP
-  END SELECT
+        CALL allocate_field(f_psm2,field_t,type_real)
+        CALL allocate_field(f_theta_rhodzm2,field_t,type_real,llm)
+        CALL allocate_field(f_um2,field_u,type_real,llm)
+    CASE default
+       PRINT*,'Bad selector for variable scheme : <', TRIM(scheme_name),             &
+            ' > options are <euler>, <runge_kutta>, <leapfrog_matsuno>'
+       STOP
+    END SELECT
+
+
+    CALL init_dissip
+    CALL init_caldyn
+    CALL init_guided
+    CALL init_advect_tracer
+    CALL init_check_conserve
+    CALL init_physics
+    CALL etat0(f_ps,f_phis,f_theta_rhodz,f_u, f_q)
+
+    CALL transfert_request(f_phis,req_i0) 
+    CALL transfert_request(f_phis,req_i1) 
+    CALL writefield("phis",f_phis,once=.TRUE.)
+
+    CALL init_message(f_ps,req_i0,req_ps0)
+    CALL init_message(f_theta_rhodz,req_i0,req_theta_rhodz0)
+    CALL init_message(f_u,req_e0_vect,req_u0)
+    CALL init_message(f_q,req_i0,req_q0)
+
+  END SUBROUTINE init_timeloop
   
-!  write_period=0
-!  CALL getin('write_period',write_period)
-!  write_period=write_period/scale_factor
-!  itau_out=FLOOR(.5+write_period/dt)
-!  PRINT *, 'Output frequency (scaled) set to ',write_period, ' : itau_out = ',itau_out
- 
-! Trends at previous time steps needed only by Adams-Bashforth
-!  CALL allocate_field(f_dpsm1,field_t,type_real)
-!  CALL allocate_field(f_dpsm2,field_t,type_real)
-!  CALL allocate_field(f_dum1,field_u,type_real,llm)
-!  CALL allocate_field(f_dum2,field_u,type_real,llm)
-!  CALL allocate_field(f_dtheta_rhodzm1,field_t,type_real,llm)
-!  CALL allocate_field(f_dtheta_rhodzm2,field_t,type_real,llm)
-!  CALL allocate_field(f_theta,field_t,type_real,llm)
-!  CALL allocate_field(f_dtheta,field_t,type_real,llm)
-
-  CALL init_dissip
-  CALL init_caldyn
-  CALL init_guided
-  CALL init_advect_tracer
-  CALL init_physics
-!========================================= INITIALIZATION 
-! CALL dynetat0(f_ps,f_phis,f_theta_rhodz,f_u,f_q)
-  CALL etat0(f_ps,f_phis,f_theta_rhodz,f_u,f_q)
-  CALL writefield("phis",f_phis,once=.TRUE.)
-  CALL transfert_request(f_q,req_i1) 
-
+  SUBROUTINE timeloop
+  USE icosa
+  USE dissip_gcm_mod
+  USE caldyn_mod
+  USE etat0_mod
+  USE guided_mod
+  USE advect_tracer_mod
+  USE physics_mod
+  USE mpipara
+  USE omp_para
+  USE trace
+  USE transfert_mod
+  USE check_conserve_mod
+  IMPLICIT NONE  
+    REAL(rstd),POINTER :: phis(:)
+    REAL(rstd),POINTER :: q(:,:,:)
+    REAL(rstd),POINTER :: ps(:) ,psm1(:), psm2(:)
+    REAL(rstd),POINTER :: u(:,:) , um1(:,:), um2(:,:)
+    REAL(rstd),POINTER :: rhodz(:,:), theta_rhodz(:,:) , theta_rhodzm1(:,:), theta_rhodzm2(:,:)
+    REAL(rstd),POINTER :: dps(:), dpsm1(:), dpsm2(:)
+    REAL(rstd),POINTER :: du(:,:), dum1(:,:), dum2(:,:)
+    REAL(rstd),POINTER :: dtheta_rhodz(:,:),dtheta_rhodzm1(:,:),dtheta_rhodzm2(:,:)
+    REAL(rstd),POINTER :: hflux(:,:),wflux(:,:),hfluxt(:,:),wfluxt(:,:)
+
+    INTEGER :: ind
+    INTEGER :: it,i,j,n,  stage
+    CHARACTER(len=255) :: scheme_name
+    LOGICAL :: fluxt_zero(ndomain) ! set to .TRUE. to start accumulating fluxes in time
+    LOGICAL, PARAMETER :: check=.FALSE.
+
+!$OMP BARRIER
   DO ind=1,ndomain
      CALL swap_dimensions(ind)
      CALL swap_geometry(ind)
      rhodz=f_rhodz(ind); ps=f_ps(ind)
-     CALL compute_rhodz(.TRUE., ps,rhodz) ! save rhodz for transport scheme before dynamics update ps
+     CALL compute_rhodz(.TRUE., ps, rhodz) ! save rhodz for transport scheme before dynamics update ps
   END DO
   fluxt_zero=.TRUE.
 
-  ! check that rhodz is consistent with ps
-  CALL transfert_request(f_rhodz,req_i1)
-  CALL transfert_request(f_ps,req_i1)
-  DO ind=1,ndomain
-     CALL swap_dimensions(ind)
-     CALL swap_geometry(ind)
-     rhodz=f_rhodz(ind); ps=f_ps(ind)
-     CALL compute_rhodz(.FALSE., ps, rhodz)   
-  END DO
-
-  CALL transfert_request(f_phis,req_i0) 
-  CALL transfert_request(f_phis,req_i1) 
-  CALL transfert_request(f_phis,req_i1) 
+! check that rhodz is consistent with ps
+!  CALL transfert_request(f_rhodz,req_i1)
+!  CALL transfert_request(f_ps,req_i1)
+!  DO ind=1,ndomain
+!     CALL swap_dimensions(ind)
+!     CALL swap_geometry(ind)
+!     rhodz=f_rhodz(ind); ps=f_ps(ind)
+!     CALL compute_rhodz(.FALSE., ps, rhodz)   
+!  END DO
+  
 
   DO it=0,itaumax
     IF (MOD(it,itau_sync)==0) THEN
-      CALL transfert_request(f_ps,req_i0)
-      CALL transfert_request(f_theta_rhodz,req_i0) 
-      CALL transfert_request(f_u,req_e0_vect)
-      CALL transfert_request(f_q,req_i0) 
+      CALL send_message(f_ps,req_ps0)
+      CALL send_message(f_theta_rhodz,req_theta_rhodz0) 
+      CALL send_message(f_u,req_u0)
+      CALL send_message(f_q,req_q0) 
+      CALL wait_message(req_ps0)
+      CALL wait_message(req_theta_rhodz0) 
+      CALL wait_message(req_u0)
+      CALL wait_message(req_q0) 
     ENDIF
     
+!    IF (is_mpi_root) PRINT *,"It No :",It,"   t :",dt*It
     IF (mod(it,itau_out)==0 ) THEN
-!      IF (is_mpi_root) PRINT *,"It No :",It,"   t :",dt*It
+      CALL writefield("q",f_q)
       CALL update_time_counter(dt*it)
-      CALL compute_conserve(f_ps,f_dps,f_u,f_theta_rhodz,f_phis,it)  
+      CALL check_conserve(f_ps,f_dps,f_u,f_theta_rhodz,f_phis,it)  
     ENDIF
-
-      CALL guided(it*dt,f_ps,f_theta_rhodz,f_u,f_q)
+    
+    CALL guided(it*dt,f_ps,f_theta_rhodz,f_u,f_q)
 
     DO stage=1,nb_stage
@@ -246,10 +252,11 @@
        CASE (mlf)
           CALL  leapfrog_matsuno_scheme(stage)
+          
           !      CASE ('leapfrog')
-          !      CALL leapfrog_scheme
+          !        CALL leapfrog_scheme
           !
           !      CASE ('adam_bashforth')
-          !      CALL dissip(f_u,f_du,f_ps,f_phis, f_theta_rhodz,f_dtheta_rhodz)
-          !      CALL adam_bashforth_scheme
+          !        CALL dissip(f_u,f_du,f_ps,f_phis, f_theta_rhodz,f_dtheta_rhodz)
+          !        CALL adam_bashforth_scheme
        CASE DEFAULT
           STOP
@@ -263,6 +270,4 @@
 
     IF(MOD(it+1,itau_adv)==0) THEN
-!       CALL transfert_request(f_wfluxt,req_i1) ! FIXME
-!      CALL transfert_request(f_hfluxt,req_e1) ! FIXME
 
        CALL advect_tracer(f_hfluxt,f_wfluxt,f_u, f_q,f_rhodz)  ! update q and rhodz after RK step
@@ -271,27 +276,26 @@
        ! FIXME : check that rhodz is consistent with ps
        IF (check) THEN
-         CALL transfert_request(f_rhodz,req_i1)
-         CALL transfert_request(f_ps,req_i1)
-         CALL transfert_request(f_dps,req_i1) ! FIXME
-         CALL transfert_request(f_wflux,req_i1) ! FIXME
          DO ind=1,ndomain
             CALL swap_dimensions(ind)
             CALL swap_geometry(ind)
-            rhodz=f_rhodz(ind); ps=f_ps(ind); dps=f_dps(ind); 
-            wflux=f_wflux(ind); wfluxt=f_wfluxt(ind)
+            rhodz=f_rhodz(ind); ps=f_ps(ind);
             CALL compute_rhodz(.FALSE., ps, rhodz)   
          END DO
        ENDIF
+
     END IF
+
+
+
 !----------------------------------------------------
-  jD_cur = jD_ref + day_ini - day_ref + it/day_step
-  jH_cur = jH_ref + start_time + mod(it,day_step)/float(day_step)
-  jD_cur = jD_cur + int(jH_cur)
-  jH_cur = jH_cur - int(jH_cur)
-!	print*,"Just b4 phys"
-    CALL physics(it,jD_cur,jH_cur,f_phis, f_ps, f_theta_rhodz, f_u, f_q)
-!----------------------------------------------------
+!    jD_cur = jD_ref + day_ini - day_ref + it/day_step
+!    jH_cur = jH_ref + start_time + mod(it,day_step)/float(day_step)
+!    jD_cur = jD_cur + int(jH_cur)
+!    jH_cur = jH_cur - int(jH_cur)
+!    CALL physics(it,jD_cur,jH_cur,f_phis, f_ps, f_theta_rhodz, f_u, f_q)
+
 !    CALL physics(it,f_phis, f_ps, f_theta_rhodz, f_u, f_q)
     ENDDO
+
  
   CONTAINS
@@ -310,10 +314,13 @@
          ps=f_ps(ind) ; dps=f_dps(ind) ; 
 
-         DO j=jj_begin,jj_end
-           DO i=ii_begin,ii_end
-             ij=(j-1)*iim+i
-             ps(ij)=ps(ij)+dt*dps(ij)
-           ENDDO
-         ENDDO
+         IF (omp_first) THEN
+           DO j=jj_begin,jj_end
+             DO i=ii_begin,ii_end
+               ij=(j-1)*iim+i
+               ps(ij)=ps(ij)+dt*dps(ij)
+             ENDDO
+           ENDDO
+         ENDIF
+         
          hflux=f_hflux(ind);     hfluxt=f_hfluxt(ind)
          wflux=f_wflux(ind);     wfluxt=f_wfluxt(ind)
@@ -324,5 +331,5 @@
        du=f_du(ind) ; dtheta_rhodz=f_dtheta_rhodz(ind)
 
-       DO l=1,llm
+       DO l=ll_begin,ll_end
          DO j=jj_begin,jj_end
            DO i=ii_begin,ii_end
@@ -342,4 +349,5 @@
 
     SUBROUTINE RK_scheme(stage)
+      USE caldyn_gcm_mod
       IMPLICIT NONE
       INTEGER :: ind, stage
@@ -351,4 +359,38 @@
 
       tau = dt*coef(stage)
+
+      DO ind=1,ndomain
+         CALL swap_dimensions(ind)
+         CALL swap_geometry(ind)
+         ps=f_ps(ind)   
+         psm1=f_psm1(ind) 
+         dps=f_dps(ind) 
+         
+         IF (stage==1) THEN ! first stage : save model state in XXm1
+           IF (omp_first) THEN
+             DO j=jj_begin,jj_end
+               DO i=ii_begin,ii_end
+                 ij=(j-1)*iim+i
+                 psm1(ij)=ps(ij)
+               ENDDO
+             ENDDO
+           ENDIF
+         END IF
+         
+         ! updates are of the form x1 := x0 + tau*f(x1)
+           IF (omp_first) THEN
+             DO j=jj_begin,jj_end
+               DO i=ii_begin,ii_end
+                 ij=(j-1)*iim+i
+                 ps(ij)=psm1(ij)+tau*dps(ij)
+               ENDDO
+             ENDDO
+           ENDIF
+       
+       ENDDO
+
+       CALL send_message(f_ps,req_ps)      
+
+
       
       DO ind=1,ndomain
@@ -360,13 +402,6 @@
          
          IF (stage==1) THEN ! first stage : save model state in XXm1
-
-           DO j=jj_begin,jj_end
-             DO i=ii_begin,ii_end
-               ij=(j-1)*iim+i
-               psm1(ij)=ps(ij)
-             ENDDO
-           ENDDO
               
-           DO l=1,llm
+         DO l=ll_begin,ll_end
              DO j=jj_begin,jj_end
                DO i=ii_begin,ii_end
@@ -382,12 +417,6 @@
          END IF
          ! updates are of the form x1 := x0 + tau*f(x1)
-         DO j=jj_begin,jj_end
-           DO i=ii_begin,ii_end
-             ij=(j-1)*iim+i
-             ps(ij)=psm1(ij)+tau*dps(ij)
-           ENDDO
-         ENDDO
          
-         DO l=1,llm
+         DO l=ll_begin,ll_end
            DO j=jj_begin,jj_end
              DO i=ii_begin,ii_end
@@ -468,5 +497,4 @@
 
         
-!        IF (MOD(it,matsuno_period+1)==0) THEN
         IF (stage==1) THEN
           psm1(:)=ps(:) ; um1(:,:)=u(:,:) ; theta_rhodzm1(:,:)=theta_rhodz(:,:)
@@ -475,5 +503,4 @@
           theta_rhodz(:,:)=theta_rhodzm1(:,:)+tau*dtheta_rhodz(:,:)
 
-!        ELSE IF (MOD(it,matsuno_period+1)==1) THEN
         ELSE IF (stage==2) THEN
 
@@ -538,4 +565,5 @@
     USE icosa
     USE disvert_mod
+    USE omp_para
     LOGICAL, INTENT(IN) :: comp ! .TRUE. to compute, .FALSE. to check
     REAL(rstd), INTENT(IN) :: ps(iim*jjm)
@@ -544,16 +572,12 @@
     INTEGER :: l,i,j,ij,dd
     err=0.
-    IF(comp) THEN 
-       dd=1
-    ELSE
-!       dd=-1
-       dd=0
-    END IF
-
-    DO l = 1, llm
+
+    dd=0
+
+    DO l = ll_begin, ll_end
        DO j=jj_begin-dd,jj_end+dd
           DO i=ii_begin-dd,ii_end+dd
              ij=(j-1)*iim+i
-             m = ( ap(l) - ap(l+1) + (bp(l)-bp(l+1))*ps(ij) )/g
+             m = ( ap(l) - ap(l+1) + (bp(l)-bp(l+1))*ps(ij) )/g 
              IF(comp) THEN
                 rhodz(ij,l) = m
@@ -570,5 +594,5 @@
           STOP
        ELSE
-          PRINT *, 'No discrepancy between ps and rhodz detected'
+!          PRINT *, 'No discrepancy between ps and rhodz detected'
        END IF
     END IF
@@ -578,4 +602,5 @@
   SUBROUTINE accumulate_fluxes(hflux,wflux, hfluxt,wfluxt, tau,fluxt_zero)
     USE icosa
+    USE omp_para
     REAL(rstd), INTENT(IN)    :: hflux(3*iim*jjm,llm), wflux(iim*jjm,llm+1)
     REAL(rstd), INTENT(INOUT) :: hfluxt(3*iim*jjm,llm), wfluxt(iim*jjm,llm+1)
@@ -585,7 +610,8 @@
 
     IF(fluxt_zero) THEN
-!       PRINT *, 'Accumulating fluxes (first)'
+
        fluxt_zero=.FALSE.
-       DO l=1,llm
+
+       DO l=ll_begin,ll_end
          DO j=jj_begin-1,jj_end+1
            DO i=ii_begin-1,ii_end+1
@@ -598,5 +624,5 @@
        ENDDO
 
-       DO l=1,llm+1
+       DO l=ll_begin,ll_endp1
          DO j=jj_begin,jj_end
            DO i=ii_begin,ii_end
@@ -607,6 +633,6 @@
        ENDDO
     ELSE
-!       PRINT *, 'Accumulating fluxes (next)'
-       DO l=1,llm
+
+       DO l=ll_begin,ll_end
          DO j=jj_begin-1,jj_end+1
            DO i=ii_begin-1,ii_end+1
@@ -619,5 +645,5 @@
        ENDDO
 
-       DO l=1,llm+1
+       DO l=ll_begin,ll_endp1
          DO j=jj_begin,jj_end
            DO i=ii_begin,ii_end
@@ -629,4 +655,5 @@
 
     END IF
+
   END SUBROUTINE accumulate_fluxes
   
Index: codes/icosagcm/trunk/src/trace.F90
===================================================================
--- codes/icosagcm/trunk/src/trace.F90	(revision 150)
+++ codes/icosagcm/trunk/src/trace.F90	(revision 151)
@@ -1,7 +1,21 @@
 MODULE trace
 
-
+  INTEGER,SAVE :: markId
+  
 CONTAINS
 
+  SUBROUTINE init_trace
+  IMPLICIT NONE
+#ifdef VTRACE
+#include <vt_user.inc>
+#endif 
+
+#ifdef VTRACE
+     VT_MARKER_DEF("marker", VT_MARKER_TYPE_HINT, markId)
+#endif
+  
+  END SUBROUTINE init_trace
+  
+  
   SUBROUTINE trace_start(name)
   IMPLICIT NONE
@@ -11,7 +25,9 @@
 #endif 
 
+!$OMP MASTER
 #ifdef VTRACE
      VT_USER_START(name)
 #endif
+!$OMP END MASTER
 
   END SUBROUTINE trace_start    
@@ -25,9 +41,26 @@
     CHARACTER(LEN=*),INTENT(IN) :: name
 
+!$OMP MASTER
 #ifdef VTRACE
      VT_USER_END(name)
 #endif
+!$OMP END MASTER
 
   END SUBROUTINE trace_end    
 
+  SUBROUTINE Marker(name)
+  IMPLICIT NONE
+  CHARACTER(LEN=*),INTENT(IN) :: name
+#ifdef VTRACE
+#include <vt_user.inc>
+#endif 
+
+!$OMP MASTER
+#ifdef VTRACE
+     VT_MARKER(markId,name)
+#endif
+!$OMP END MASTER
+
+  END SUBROUTINE Marker
+
 END MODULE trace
Index: codes/icosagcm/trunk/src/transfert.F90
===================================================================
--- codes/icosagcm/trunk/src/transfert.F90	(revision 150)
+++ codes/icosagcm/trunk/src/transfert.F90	(revision 151)
@@ -3,8 +3,12 @@
 #ifdef CPP_USING_MPI
   USE transfert_mpi_mod, ONLY : init_transfert, transfert_request=>transfert_request_mpi, req_i1,req_e1_vect, &
-                                req_e1_scal, req_i0, req_e0_vect, req_e0_scal, request_add_point, create_request, gather_field
+                                req_e1_scal, req_i0, req_e0_vect, req_e0_scal, request_add_point, create_request, gather_field, &
+                                t_message,init_message=>init_message_mpi,transfert_message=>transfert_message_mpi,  &
+                                send_message=>send_message_mpi,test_message=>test_message_mpi,wait_message=>wait_message_mpi,barrier
 #else 
-  USE transfert_mpi_mod, ONLY : init_transfert, transfert_request, req_i1,req_e1_vect, &
-                                req_e1_scal,request_add_point, create_request, gather_field
+  USE transfert_mpi_mod, ONLY : init_transfert, transfert_request=>transfert_request_seq, req_i1,req_e1_vect, &
+                                req_e1_scal,req_i0, req_e0_vect, req_e0_scal, request_add_point, create_request, gather_field, &
+                                t_message,init_message=>init_message_seq,transfert_message=>transfert_message_seq,  &
+                                send_message=>send_message_seq,test_message=>test_message_seq,wait_message=>wait_message_seq,barrier
 #endif
   
